// $Id: main.cpp,v 1.4 2006/05/15 22:09:22 jyeh Exp $
// holds the main()

/*
// CodeAnalyst for Open Source
// Copyright 2002 . 2005 Advanced Micro Devices, Inc.
// You may redistribute this program and/or modify this program under the terms
// of the GNU General Public License as published by the Free Software 
// Foundation; either version 2 of the License, or (at your option) any later 
// version.
//
// This program is distributed WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED 
// WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  See the 
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License along with
// this program; if not, write to the Free Software Foundation, Inc., 59 Temple
// Place, Suite 330, Boston, MA 02111-1307 USA.
*/

#include <time.h>
#include <unistd.h>
#include <stdio.h>

#include <qsplashscreen.h>

#include "stdafx.h"
#include "xp.h"
#include "application.h"
#include <dlfcn.h>


#define CODEANALYST_SPLASH          "CASplash.png"

void showVersion()
{
	fprintf(stdout,"%s\n",PACKAGE_STRING);	
	fprintf(stdout,"  Built on : %s %s\n",__DATE__,__TIME__);	
	fprintf(stdout,"  Contacts : %s \n",PACKAGE_BUGREPORT);	
	fprintf(stdout,"  Configure detail :\n  %s\n",CA_CONFIG_ARG);	
}

int main ( int argc, char ** argv ) 
{
	int ret_value = 0;

	if(argc == 2)
	{
		if(0 == strcmp(argv[1],"--version"))
		{
			showVersion();
			return 0;
		}
	}

	QApplication a (argc, argv);

	QString BinDirectory = QString(CA_DATA_DIR) + "/" + CODEANALYST_SPLASH;
	QSplashScreen splash ( QPixmap(BinDirectory), Qt::WStyle_StaysOnTop);
	splash.show();

	ApplicationWindow * mw = new ApplicationWindow();
	splash.finish (mw);
	mw->setCaption( "Advanced Micro Devices - CodeAnalyst Performance Analyzer" );
	mw->show();

	a.connect ( &a, SIGNAL (lastWindowClosed()), &a, SLOT (quit()) );
	//a.syncX();
	ret_value =  a.exec();
	//a.syncX();
	return ret_value;

}
